/* scan.c -- convert strings into data
 * Copyright (C) 1994 David Deaven
 *
 * This file is part of xyplot.
 *
 * xyplot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * xyplot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with xyplot; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: scan.c,v 1.2 1995/09/05 13:59:38 deaven Exp $
 */
#include <stdio.h>
#include <ctype.h>
#include "xyplot.h"

/* Read a number from the string (which may be modified).
   Do not change *f if there's a problem, and return -1.
 */
int XYfloatscan(char *s, double *f)
{
  int i=0;
  double ff;
  while(s[i]!='\0') {
    if(tolower(s[i])=='d')s[i]='e';
    ++i;
  }
  if(sscanf(s, "%lf", &ff) != 1)return -1;
  *f = ff;
  return 0;
}

/* Read an integer from the string.
   Do not change *i if there's a problem, and return -1.
 */
int XYintscan(char *s, int *i)
{
  double f;
  f=*i;
  if(XYfloatscan(s,&f)>=0)
  {
    *i=f;
    return 0;
  }
  return -1;
}
